﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.3
@EndOfDesignText@
'Custom View class
'#Event: ExampleEvent (Value As Int)
'#DesignerProperty: Key: BooleanExample, DisplayName: Boolean Example, FieldType: Boolean, DefaultValue: True, Description: Example of a boolean property.
'#DesignerProperty: Key: IntExample, DisplayName: Int Example, FieldType: Int, DefaultValue: 10, MinRange: 0, MaxRange: 100, Description: Note that MinRange and MaxRange are optional.
'#DesignerProperty: Key: StringWithListExample, DisplayName: String With List, FieldType: String, DefaultValue: Sunday, List: Sunday|Monday|Tuesday|Wednesday|Thursday|Friday|Saturday
'#DesignerProperty: Key: StringExample, DisplayName: String Example, FieldType: String, DefaultValue: Text
'#DesignerProperty: Key: ColorExample, DisplayName: Color Example, FieldType: Color, DefaultValue: 0xFFCFDCDC, Description: You can use the built-in color picker to find the color values.
'#DesignerProperty: Key: DefaultColorExample, DisplayName: Default Color Example, FieldType: Color, DefaultValue: Null, Description: Setting the default value to Null means that a nullable field will be displayed.
Sub Class_Globals
	Private fx As JFX
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As Pane
	Private TJO As JavaObject
	Private ListenersMap As Map
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	ListenersMap.Initialize
End Sub

Public Sub DesignerCreateView (Base As Pane, Lbl As Label, Props As Map)
	mBase = Base
	
End Sub


Private Sub Base_Resize (Width As Double, Height As Double)
	If TJO.IsInitialized Then
		
		AsNode.PrefWidth = Width
		AsNode.PrefHeight = Height
	End If
End Sub

Public Sub GetBase As Pane
	Return mBase
End Sub

Public Sub SetObject(Obj As Object)
	TJO = Obj
	mBase.AddNode(TJO,0,0,mBase.PrefWidth,mBase.PrefHeight)
End Sub

Public Sub AsNode As Node
	Return TJO
End Sub

'Returns the wrapped object as JavaObject
Public Sub AsJO As JavaObject
	Return TJO
End Sub


'MISSING COMMENT FOR THIS LINE
Public Sub Create
  'If a JavaObject has been passed, you may need to create it here and remove the parameter
  TJO.InitializeNewInstance("eu.hansolo.tilesfx.Tile",Null)
End Sub

'MISSING COMMENT FOR THIS LINE
Public Sub Create2(SKIN_TYPE As String)
  'If a JavaObject has been passed, you may need to create it here and remove the parameter
  TJO.InitializeNewInstance("eu.hansolo.tilesfx.Tile",Array As Object(SKIN_TYPE))
End Sub

'MISSING COMMENT FOR THIS LINE
Public Sub ActiveColorProperty As JavaObject
  Return TJO.RunMethod("activeColorProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub ActiveProperty As JavaObject
  Return TJO.RunMethod("activeProperty",Null)
End Sub
'Adds the given Alarm object from the list of alarms.
Public Sub AddAlarm(ALARM As JavaObject)
  TJO.RunMethod("addAlarm",Array As Object(ALARM))
End Sub
'MISSING COMMENT FOR THIS LINE
'Replace "FullClassName" with the full name of the listener class in B4a, or the EventHandler in B4j
Public Sub AddAlarmEventListener(Module As Object, EventName As String) As Object
  Dim Listeners As List
      Listeners.Initialize
      Dim LL As List = ListenersMap.Get("AddAlarmEventListener")
      If LL.IsInitialized Then Listeners.AddAll(LL)
  If Listeners.Size = 0 Then 
    Dim EventObject As Object = TJO.CreateEventFromUI("FullClassName", "Listener0" ,Null)
    TJO.RunMethod("addAlarmEventListener",Array As Object(EventObject))
  End If
      'Depending on the type of listener, this code may not be needed, but is left here just in case.
      'It is safe to delete this and references to ListenerMap And Listenertype if they are not needed.
  Dim LT As ListenerType
  LT.Initialize
  LT.Module = Module
  LT.EventName = EventName
  Listeners.Add(LT)
  ListenersMap.Put("AddAlarmEventListener",Listeners)
  Return EventObject
End Sub
Private Sub Listener0_Event(MethodName As String,Args() As Object)
  Dim Listeners As List = ListenersMap.Get("AddAlarmEventListener")
  If Listeners.IsInitialized Then
    For Each LT As ListenerType In Listeners
      If SubExists(LT.Module, LT.EventName & "_Event") Then CallSub2(LT.Module, LT.EventName & "_Event",Args)
    Next
  End If
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub AddBarChartItem(ITEM As BarChartItem)
  TJO.RunMethod("addBarChartItem",Array As Object(ITEM.GetObject))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub AddChartData(DATA() As JavaObject)
	Dim LI As List
	LI.Initialize
	For Each CD As Object In DATA
  		LI.Add(CD)
	Next
	AddChartData2(LI)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub AddChartData2(DATA As List)
  TJO.RunMethod("addChartData",Array As Object(DATA))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub AddLeaderBoardItem(ITEM As JavaObject)
  TJO.RunMethod("addLeaderBoardItem",Array As Object(ITEM))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub AddPoiLocation(TLOCATION As Location)
  TJO.RunMethod("addPoiLocation",Array As Object(TLOCATION.GetObject))
End Sub
'Adds the given Section to the list of sections.
Public Sub AddSection(TSECTION As Section)
  TJO.RunMethod("addSection",Array As Object(TSECTION.GetObject))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub AddSeries(SERIES As JavaObject)
  TJO.RunMethod("addSeries",Array As Object(SERIES))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub AddTileEventListener(Module As Object, EventName As String) As Object
  Dim Listeners As List
      Listeners.Initialize
      Dim LL As List = ListenersMap.Get("AddTileEventListener")
      If LL.IsInitialized Then Listeners.AddAll(LL)
  If Listeners.Size = 0 Then 
    Dim EventObject As Object = TJO.CreateEventFromUI("FullClassName", "Listener1" ,Null)
    TJO.RunMethod("addTileEventListener",Array As Object(EventObject))
  End If
      'Depending on the type of listener, this code may not be needed, but is left here just in case.
      'It is safe to delete this and references to ListenerMap And Listenertype if they are not needed.
  Dim LT As ListenerType
  LT.Initialize
  LT.Module = Module
  LT.EventName = EventName
  Listeners.Add(LT)
  ListenersMap.Put("AddTileEventListener",Listeners)
  Return EventObject
End Sub
Private Sub Listener1_Event(MethodName As String,Args() As Object)
  Dim Listeners As List = ListenersMap.Get("AddTileEventListener")
  If Listeners.IsInitialized Then
    For Each LT As ListenerType In Listeners
      If SubExists(LT.Module, LT.EventName & "_Event") Then CallSub2(LT.Module, LT.EventName & "_Event",Args)
    Next
  End If
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub AddTilesFXSeries(SERIES As TilesFXSeries)
  TJO.RunMethod("addTilesFXSeries",Array As Object(SERIES.GetObject))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub AddTimeEventListener(Module As Object, EventName As String) As Object
  Dim Listeners As List
      Listeners.Initialize
      Dim LL As List = ListenersMap.Get("AddTimeEventListener")
      If LL.IsInitialized Then Listeners.AddAll(LL)
  If Listeners.Size = 0 Then 
    Dim EventObject As Object = TJO.CreateEventFromUI("FullClassName", "Listener2" ,Null)
    TJO.RunMethod("addTimeEventListener",Array As Object(EventObject))
  End If
      'Depending on the type of listener, this code may not be needed, but is left here just in case.
      'It is safe to delete this and references to ListenerMap And Listenertype if they are not needed.
  Dim LT As ListenerType
  LT.Initialize
  LT.Module = Module
  LT.EventName = EventName
  Listeners.Add(LT)
  ListenersMap.Put("AddTimeEventListener",Listeners)
  Return EventObject
End Sub
Private Sub Listener2_Event(MethodName As String,Args() As Object)
  Dim Listeners As List = ListenersMap.Get("AddTimeEventListener")
  If Listeners.IsInitialized Then
    For Each LT As ListenerType In Listeners
      If SubExists(LT.Module, LT.EventName & "_Event") Then CallSub2(LT.Module, LT.EventName & "_Event",Args)
    Next
  End If
End Sub
'Adds the given TimeSection to the list of sections.
Public Sub AddTimeSection(TSECTION As TimeSection)
  TJO.RunMethod("addTimeSection",Array As Object(TSECTION.GetObject))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub AlarmColorProperty As JavaObject
  Return TJO.RunMethod("alarmColorProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub AlarmsEnabledProperty As JavaObject
  Return TJO.RunMethod("alarmsEnabledProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub AlarmsVisibleProperty As JavaObject
  Return TJO.RunMethod("alarmsVisibleProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub AlertMessageProperty As JavaObject
  Return TJO.RunMethod("alertMessageProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub AlertProperty As JavaObject
  Return TJO.RunMethod("alertProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub AngleRangeProperty As JavaObject
  Return TJO.RunMethod("angleRangeProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub AngleStepProperty As JavaObject
  Return TJO.RunMethod("angleStepProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub AnimatedProperty As JavaObject
  Return TJO.RunMethod("animatedProperty",Null)
End Sub

'MISSING COMMENT FOR THIS LINE
Public Sub AutoReferenceValueProperty As JavaObject
  Return TJO.RunMethod("autoReferenceValueProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub AutoScaleProperty As JavaObject
  Return TJO.RunMethod("autoScaleProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub AverageVisibleProperty As JavaObject
  Return TJO.RunMethod("averageVisibleProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub AveragingEnabledProperty As JavaObject
  Return TJO.RunMethod("averagingEnabledProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub AveragingPeriodProperty As JavaObject
  Return TJO.RunMethod("averagingPeriodProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub BackgroundColorProperty As JavaObject
  Return TJO.RunMethod("backgroundColorProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub BarBackgroundColorProperty As JavaObject
  Return TJO.RunMethod("barBackgroundColorProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub BarColorProperty As JavaObject
  Return TJO.RunMethod("barColorProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub BorderColorProperty As JavaObject
  Return TJO.RunMethod("borderColorProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub BorderWidthProperty As JavaObject
  Return TJO.RunMethod("borderWidthProperty",Null)
End Sub
'Calling this method will lead to a recalculation of the scale
Public Sub CalcAutoScale
  TJO.RunMethod("calcAutoScale",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub ChartGridColorProperty As JavaObject
  Return TJO.RunMethod("chartGridColorProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub CheckSectionsForValueProperty As JavaObject
  Return TJO.RunMethod("checkSectionsForValueProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub CheckThresholdProperty As JavaObject
  Return TJO.RunMethod("checkThresholdProperty",Null)
End Sub
'Clears the list of alarms.
Public Sub ClearAlarms
  TJO.RunMethod("clearAlarms",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub ClearBarChartItems
  TJO.RunMethod("clearBarChartItems",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub ClearChartData
  TJO.RunMethod("clearChartData",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub ClearLeaderBoardItems
  TJO.RunMethod("clearLeaderBoardItems",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub ClearPoiLocations
  TJO.RunMethod("clearPoiLocations",Null)
End Sub
'Clears the list of sections.
Public Sub ClearSections
  TJO.RunMethod("clearSections",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub ClearSeries
  TJO.RunMethod("clearSeries",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub ClearTilesFXSeries
  TJO.RunMethod("clearTilesFXSeries",Null)
End Sub
'Clears the list of sections.
Public Sub ClearTimeSections
  TJO.RunMethod("clearTimeSections",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub ClearTrack
  TJO.RunMethod("clearTrack",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub CountryGroupProperty As JavaObject
  Return TJO.RunMethod("countryGroupProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub CountryProperty As JavaObject
  Return TJO.RunMethod("countryProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub CurrentLocationProperty As JavaObject
  Return TJO.RunMethod("currentLocationProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub CurrentTimeProperty As JavaObject
  Return TJO.RunMethod("currentTimeProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub CurrentValueProperty As JavaObject
  Return TJO.RunMethod("currentValueProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub CustomFontEnabledProperty As JavaObject
  Return TJO.RunMethod("customFontEnabledProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub CustomFontProperty As JavaObject
  Return TJO.RunMethod("customFontProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub DataPointsVisibleProperty As JavaObject
  Return TJO.RunMethod("dataPointsVisibleProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub DateColorProperty As JavaObject
  Return TJO.RunMethod("dateColorProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub DateVisibleProperty As JavaObject
  Return TJO.RunMethod("dateVisibleProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub DecimalsProperty As JavaObject
  Return TJO.RunMethod("decimalsProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub DescriptionAlignmentProperty As JavaObject
  Return TJO.RunMethod("descriptionAlignmentProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub DescriptionColorProperty As JavaObject
  Return TJO.RunMethod("descriptionColorProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub DescriptionProperty As JavaObject
  Return TJO.RunMethod("descriptionProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub DiscreteHoursProperty As JavaObject
  Return TJO.RunMethod("discreteHoursProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub DiscreteMinutesProperty As JavaObject
  Return TJO.RunMethod("discreteMinutesProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub DiscreteSecondsProperty As JavaObject
  Return TJO.RunMethod("discreteSecondsProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub DurationProperty As JavaObject
  Return TJO.RunMethod("durationProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub FillWithGradientProperty As JavaObject
  Return TJO.RunMethod("fillWithGradientProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub FireAlarmEvent(EVENT As JavaObject)
  TJO.RunMethod("fireAlarmEvent",Array As Object(EVENT))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub FireTileEvent(EVENT As JavaObject)
  TJO.RunMethod("fireTileEvent",Array As Object(EVENT))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub FireTimeEvent(EVENT As JavaObject)
  TJO.RunMethod("fireTimeEvent",Array As Object(EVENT))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub FlipTextProperty As JavaObject
  Return TJO.RunMethod("flipTextProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub ForegroundColorProperty As JavaObject
  Return TJO.RunMethod("foregroundColorProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub FormerValueProperty As JavaObject
  Return TJO.RunMethod("formerValueProperty",Null)
End Sub
'Gets the value of the property activeColor.
Public Sub GetActiveColor As Paint
  Return TJO.RunMethod("getActiveColor",Null)
End Sub
'Returns the color that will be used to colorize the alarm icon.
Public Sub GetAlarmColor As Paint
  Return TJO.RunMethod("getAlarmColor",Null)
End Sub
'Returns an observable list of Alarm objects.
Public Sub GetAlarms As List
  Return TJO.RunMethod("getAlarms",Null)
End Sub
'Returns the alert message text that could be used in a tooltip in case of an alert.
Public Sub GetAlertMessage As String
  Return TJO.RunMethod("getAlertMessage",Null)
End Sub
'Returns the angle range in degree that will be used to draw the scale of the radial gauge.
Public Sub GetAngleRange As Double
  Return TJO.RunMethod("getAngleRange",Null)
End Sub
'Returns the value that is calculated by dividing the angleRange by the range.
Public Sub GetAngleStep As Double
  Return TJO.RunMethod("getAngleStep",Null)
End Sub
'Returns the duration in milliseconds that will be used to animate the needle/bar of the gauge from the last value to the next value.
Public Sub GetAnimationDuration As Long
  Return TJO.RunMethod("getAnimationDuration",Null)
End Sub
'Returns the moving average over the number of values defined by averagingPeriod.
Public Sub GetAverage As Double
  Return TJO.RunMethod("getAverage",Null)
End Sub
'Returns the number of values that should be used for the averaging of values.
Public Sub GetAveragingPeriod As Int
  Return TJO.RunMethod("getAveragingPeriod",Null)
End Sub
'Returns a deep copy of the current list of Data objects that will be used to calculate the moving average.
Public Sub GetAveragingWindow As JavaObject
  Return TJO.RunMethod("getAveragingWindow",Null)
End Sub
'Returns the Paint object that will be used to fill the gauge background.
Public Sub GetBackgroundColor As Paint
  Return TJO.RunMethod("getBackgroundColor",Null)
End Sub
'Returns the color that will be used to colorize the bar background of the gauge (if it has a bar).
Public Sub GetBarBackgroundColor As Paint
  Return TJO.RunMethod("getBarBackgroundColor",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub GetBarChartItems As List
  Return TJO.RunMethod("getBarChartItems",Null)
End Sub
'Returns the color that will be used to colorize the bar of the gauge (if it has a bar).
Public Sub GetBarColor As Paint
  Return TJO.RunMethod("getBarColor",Null)
End Sub
'Returns the Paint object that will be used to draw the border of the gauge.
Public Sub GetBorderColor As Paint
  Return TJO.RunMethod("getBorderColor",Null)
End Sub
'Returns the width in pixels that will be used to draw the border of the gauge.
Public Sub GetBorderWidth As Double
  Return TJO.RunMethod("getBorderWidth",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub GetCharacterList As List
  Return TJO.RunMethod("getCharacterList",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub GetChartData As List
  Return TJO.RunMethod("getChartData",Null)
End Sub
'Returns the color that will be used to colorize lines in charts e.g.
Public Sub GetChartGridColor As Paint
  Return TJO.RunMethod("getChartGridColor",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub GetChartType As JavaObject
  Return TJO.RunMethod("getChartType",Null)
End Sub
'Returns true if the value of the gauge should be checked against all sections (if sections not empty).
Public Sub GetCheckSectionsForValue As Boolean
  Return TJO.RunMethod("getCheckSectionsForValue",Null)
End Sub
'Returns the Locale that will be used to visualize the country in the CountryTileSkin
Public Sub GetCountry As JavaObject
  Return TJO.RunMethod("getCountry",Null)
End Sub
'Gets the value of the property countryGroup.
Public Sub GetCountryGroup As JavaObject
  Return TJO.RunMethod("getCountryGroup",Null)
End Sub
'Returns a list of path elements that define the countries
Public Sub GetCountryPaths As JavaObject
  Return TJO.RunMethod("getCountryPaths",Null)
End Sub
'Gets the value of the property currentLocation.
Public Sub GetCurrentLocation As Location
	Dim L As Location
	L.Initialize
	L.SetObject(TJO.RunMethod("getCurrentLocation",Null))
	Return L
End Sub
'Returns the current time in epoch seconds
Public Sub GetCurrentTime As Long
  Return TJO.RunMethod("getCurrentTime",Null)
End Sub
'Returns the current value of the Tile.
Public Sub GetCurrentValue As Double
  Return TJO.RunMethod("getCurrentValue",Null)
End Sub
'Returns the given custom Font that can be used to render all text elements.
Public Sub GetCustomFont As Font
  Return TJO.RunMethod("getCustomFont",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub GetDarkSky As JavaObject
  Return TJO.RunMethod("getDarkSky",Null)
End Sub
'Gets the value of the property dataPointsVisible.
Public Sub GetDataPointsVisible As Boolean
  Return TJO.RunMethod("getDataPointsVisible",Null)
End Sub
'Returns the color that will be used to colorize the date of the clock.
Public Sub GetDateColor As Paint
  Return TJO.RunMethod("getDateColor",Null)
End Sub
'Returns the number of decimals that will be used to format the value of the gauge.
Public Sub GetDecimals As Int
  Return TJO.RunMethod("getDecimals",Null)
End Sub
'Returns the description text of the gauge.
Public Sub GetDescription As String
  Return TJO.RunMethod("getDescription",Null)
End Sub
'Returns the current alignment of the description text (esp.
Public Sub GetDescriptionAlignment As JavaObject
  Return TJO.RunMethod("getDescriptionAlignment",Null)
End Sub
'Returns the color that will be used to colorize the description text of the gauge.
Public Sub GetDescriptionColor As Paint
  Return TJO.RunMethod("getDescriptionColor",Null)
End Sub
'Returns a duration that will be used in the TimeTileSkin
Public Sub GetDuration As JavaObject
  Return TJO.RunMethod("getDuration",Null)
End Sub
'Returns the text that will be used to visualized the FlipTileSkin
Public Sub GetFlipText As String
  Return TJO.RunMethod("getFlipText",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub GetFlipTimeInMS As Long
  Return TJO.RunMethod("getFlipTimeInMS",Null)
End Sub
'Returns the Paint object that will be used to fill the gauge foreground.
Public Sub GetForegroundColor As Paint
  Return TJO.RunMethod("getForegroundColor",Null)
End Sub
'Returns the last value of the Tile.
Public Sub GetFormerValue As Double
  Return TJO.RunMethod("getFormerValue",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub GetGradientStops As List
  Return TJO.RunMethod("getGradientStops",Null)
End Sub
'Returns an optional node that can be used in combination with the CustomTileSkin
Public Sub GetGraphic As Node
  Return TJO.RunMethod("getGraphic",Null)
End Sub
'Returns the color that will be used to colorize the hour hand of the clock.
Public Sub GetHourColor As Paint
  Return TJO.RunMethod("getHourColor",Null)
End Sub
'Returns the color that will be used to colorize the hour tickmarks of the clock.
Public Sub GetHourTickMarkColor As Paint
  Return TJO.RunMethod("getHourTickMarkColor",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub GetIncrement As Double
  Return TJO.RunMethod("getIncrement",Null)
End Sub
'Returns the color that will be used to colorize the knob of the radial gauges.
Public Sub GetKnobColor As Paint
  Return TJO.RunMethod("getKnobColor",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub GetLeaderBoardItems As List
  Return TJO.RunMethod("getLeaderBoardItems",Null)
End Sub
'Gets the value of the property locale.
Public Sub GetLocale As JavaObject
  Return TJO.RunMethod("getLocale",Null)
End Sub
'The distance between 2 major tick marks (used in SliderTileSkin)
Public Sub GetMajorTickUnit As Double
  Return TJO.RunMethod("getMajorTickUnit",Null)
End Sub
'Gets the value of the property mapProvider.
Public Sub GetMapProvider As JavaObject
  Return TJO.RunMethod("getMapProvider",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub GetMatrixSize As Int()
  Return TJO.RunMethod("getMatrixSize",Null)
End Sub
'Returns the biggest value that was measured after the last reset.
Public Sub GetMaxMeasuredValue As Double
  Return TJO.RunMethod("getMaxMeasuredValue",Null)
End Sub
'Returns the maximum value of the scale.
Public Sub GetMaxValue As Double
  Return TJO.RunMethod("getMaxValue",Null)
End Sub
'Returns the smallest value that was measured after the last reset.
Public Sub GetMinMeasuredValue As Double
  Return TJO.RunMethod("getMinMeasuredValue",Null)
End Sub
'The number of ticks between 2 major tick marks (used in SliderTileSkin)
Public Sub GetMinorTickCount As Int
  Return TJO.RunMethod("getMinorTickCount",Null)
End Sub
'Returns the color that will be used to colorize the minute hand of the clock.
Public Sub GetMinuteColor As Paint
  Return TJO.RunMethod("getMinuteColor",Null)
End Sub
'Returns the color that will be used to colorize the minute tickmarks of the clock.
Public Sub GetMinuteTickMarkColor As Paint
  Return TJO.RunMethod("getMinuteTickMarkColor",Null)
End Sub
'Returns the minimum value of the scale.
Public Sub GetMinValue As Double
  Return TJO.RunMethod("getMinValue",Null)
End Sub
'Returns the moving average object
Public Sub GetMovingAverage As JavaObject
  Return TJO.RunMethod("getMovingAverage",Null)
End Sub
'Returns the color that will be used to colorize the needle of the radial gauges.
Public Sub GetNeedleColor As Paint
  Return TJO.RunMethod("getNeedleColor",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub GetNotificationBackgroundColor As Paint
  Return TJO.RunMethod("getNotificationBackgroundColor",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub GetNotificationForegroundColor As Paint
  Return TJO.RunMethod("getNotificationForegroundColor",Null)
End Sub
'Returns the number format that will be used to format the value in the gauge (NOT USED AT THE MOMENT)
Public Sub GetNumberFormat As JavaObject
  Return TJO.RunMethod("getNumberFormat",Null)
End Sub
'Returns the wrapped object as Object
Public Sub GetObject As Object
  Return TJO
End Sub
'Returns the last value of the Tile.
Public Sub GetOldValue As Double
  Return TJO.RunMethod("getOldValue",Null)
End Sub
'Returns the orientation of the control.
Public Sub GetOrientation As String
  Return TJO.RunMethodJO("getOrientation",Null).RunMethod("toString",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub GetPoiList As List
  Return TJO.RunMethod("getPoiList",Null)
End Sub
'Returns the mode of the RadarChartTileSkin.
Public Sub GetRadarChartMode As JavaObject
  Return TJO.RunMethod("getRadarChartMode",Null)
End Sub
'Always returns the range of the gauge scale (maxValue - minValue).
Public Sub GetRange As Double
  Return TJO.RunMethod("getRange",Null)
End Sub
'Returns the reference value that will be used in the HighLowTileSkin to visualize the increase or decrease of the current value compared to the reference value;
Public Sub GetReferenceValue As Double
  Return TJO.RunMethod("getReferenceValue",Null)
End Sub
'Returns true if the corners of the Tiles are rounded
Public Sub GetRoundedCorners As Boolean
  Return TJO.RunMethod("getRoundedCorners",Null)
End Sub
'Returns the color that will be used to colorize the second hand of the clock.
Public Sub GetSecondColor As Paint
  Return TJO.RunMethod("getSecondColor",Null)
End Sub
'Returns true if the icon of the sections should be drawn inside the sections.
Public Sub GetSectionIconsVisible As Boolean
  Return TJO.RunMethod("getSectionIconsVisible",Null)
End Sub
'Returns an observable list of Section objects.
Public Sub GetSections As List
  Return TJO.RunMethod("getSections",Null)
End Sub
'Returns true if the sections in the IndicatorSkin will always be visible
Public Sub GetSectionsAlwaysVisible As Boolean
  Return TJO.RunMethod("getSectionsAlwaysVisible",Null)
End Sub
'Returns true if the sections will be drawn
Public Sub GetSectionsVisible As Boolean
  Return TJO.RunMethod("getSectionsVisible",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub GetSeries As JavaObject
  Return TJO.RunMethod("getSeries",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub GetSkinType As JavaObject
  Return TJO.RunMethod("getSkinType",Null)
End Sub
'Returns the angle in degree that defines the start of the scale with it's minValue in a radial gauge.
Public Sub GetStartAngle As Double
  Return TJO.RunMethod("getStartAngle",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub GetSunburstChart As JavaObject
  Return TJO.RunMethod("getSunburstChart",Null)
End Sub
'Returns the text that was defined for the clock.
Public Sub GetText As String
  Return TJO.RunMethod("getText",Null)
End Sub
'Returns the alignment that will be used to align the text in the Tile.
Public Sub GetTextAlignment As String
  Return TJO.RunMethod("getTextAlignment",Null)
End Sub
'Returns the color that will be used to colorize the text of the clock.
Public Sub GetTextColor As Paint
  Return TJO.RunMethod("getTextColor",Null)
End Sub
'Returns the text size that will be used for the title, subtitle and text in the different skins.
Public Sub GetTextSize As JavaObject
  Return TJO.RunMethod("getTextSize",Null)
End Sub
'Returns the threshold value that can be used to visualize a threshold value on the scale.
Public Sub GetThreshold As Double
  Return TJO.RunMethod("getThreshold",Null)
End Sub
'Returns the color that will be used to colorize the threshold indicator of the gauge.
Public Sub GetThresholdColor As Paint
  Return TJO.RunMethod("getThresholdColor",Null)
End Sub
'Returns the number of tickLabelDecimals that will be used to format the ticklabels of the gauge.
Public Sub GetTickLabelDecimals As Int
  Return TJO.RunMethod("getTickLabelDecimals",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub GetTilesFXSeries As JavaObject
  Return TJO.RunMethod("getTilesFXSeries",Null)
End Sub
'Returns the current time of the clock.
Public Sub GetTime As JavaObject
  Return TJO.RunMethod("getTime",Null)
End Sub
'Returns the moving average over the given duration.
Public Sub GetTimeBasedAverageOf(DURATION As JavaObject) As Double
  Return TJO.RunMethod("getTimeBasedAverageOf",Array As Object(DURATION))
End Sub
'Returns an observable list of TimeSection objects.
Public Sub GetTimeSections As List
  Return TJO.RunMethod("getTimeSections",Null)
End Sub
'Returns the title of the gauge.
Public Sub GetTitle As String
  Return TJO.RunMethod("getTitle",Null)
End Sub
'Returns the alignment that will be used to align the title in the Tile.
Public Sub GetTitleAlignment As String
  Return TJO.RunMethod("getTitleAlignment",Null)
End Sub
'Returns the color that will be used to colorize the title of the gauge.
Public Sub GetTitleColor As Paint
  Return TJO.RunMethod("getTitleColor",Null)
End Sub
'Returns the text that will be shown in the Tile tooltip
Public Sub GetTooltipText As String
  Return TJO.RunMethod("getTooltipText",Null)
End Sub
'Gets the value of the property tooltipTimeout.
Public Sub GetTooltipTimeout As Double
  Return TJO.RunMethod("getTooltipTimeout",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub GetTrack As List
  Return TJO.RunMethod("getTrack",Null)
End Sub
'Gets the value of the property trackColor.
Public Sub GetTrackColor As Paint
  Return TJO.RunMethod("getTrackColor",Null)
End Sub
'Returns the unit of the gauge.
Public Sub GetUnit As String
  Return TJO.RunMethod("getUnit",Null)
End Sub
'Returns the color that will be used to colorize the unit of the gauge.
Public Sub GetUnitColor As Paint
  Return TJO.RunMethod("getUnitColor",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub GetUserAgentStylesheet As String
  Return TJO.RunMethod("getUserAgentStylesheet",Null)
End Sub
'Returns the value of the Tile.
Public Sub GetValue As Double
  Return TJO.RunMethod("getValue",Null)
End Sub
'Returns the color that will be used to colorize the value of the gauge.
Public Sub GetValueColor As Paint
  Return TJO.RunMethod("getValueColor",Null)
End Sub
'Gets the value of the property xAxis.
Public Sub GetXAxis As JavaObject
  Return TJO.RunMethod("getXAxis",Null)
End Sub
'Gets the value of the property yAxis.
Public Sub GetYAxis As JavaObject
  Return TJO.RunMethod("getYAxis",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub GetZoneId As JavaObject
  Return TJO.RunMethod("getZoneId",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub GraphicProperty As JavaObject
  Return TJO.RunMethod("graphicProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub HighlightSectionsProperty As JavaObject
  Return TJO.RunMethod("highlightSectionsProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub HourColorProperty As JavaObject
  Return TJO.RunMethod("hourColorProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub HourTickMarkColorProperty As JavaObject
  Return TJO.RunMethod("hourTickMarkColorProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub HourTickMarksVisibleProperty As JavaObject
  Return TJO.RunMethod("hourTickMarksVisibleProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub InnerShadowEnabledProperty As JavaObject
  Return TJO.RunMethod("innerShadowEnabledProperty",Null)
End Sub
'Returns true if the switch in the SwitchTileSkin is active
Public Sub IsActive As Boolean
  Return TJO.RunMethod("isActive",Null)
End Sub
'Returns true if alarms are enabled.
Public Sub IsAlarmsEnabled As Boolean
  Return TJO.RunMethod("isAlarmsEnabled",Null)
End Sub
'Returns true if alarm markers should be drawn.
Public Sub IsAlarmsVisible As Boolean
  Return TJO.RunMethod("isAlarmsVisible",Null)
End Sub
'Returns true if the alert property was set.
Public Sub IsAlert As Boolean
  Return TJO.RunMethod("isAlert",Null)
End Sub
'Returns true if setting the value of the gauge will be animated using the duration defined in animationDuration [ms].
Public Sub IsAnimated As Boolean
  Return TJO.RunMethod("isAnimated",Null)
End Sub
'Returns true if the reference value for the StockTileSkin will be calculated automatically
Public Sub IsAutoReferenceValue As Boolean
  Return TJO.RunMethod("isAutoReferenceValue",Null)
End Sub
'Returns true if the scale will be calculated automatically based on the defined values for min- and maxValue.
Public Sub IsAutoScale As Boolean
  Return TJO.RunMethod("isAutoScale",Null)
End Sub
'Returns true if the average indicator should be drawn.
Public Sub IsAverageVisible As Boolean
  Return TJO.RunMethod("isAverageVisible",Null)
End Sub
'Returns true if the averaging functionality is enabled.
Public Sub IsAveragingEnabled As Boolean
  Return TJO.RunMethod("isAveragingEnabled",Null)
End Sub
'Returns true if the value of the gauge should be checked against the threshold.
Public Sub IsCheckThreshold As Boolean
  Return TJO.RunMethod("isCheckThreshold",Null)
End Sub
'Returns true if the control uses the given customFont to render all text elements.
Public Sub IsCustomFontEnabled As Boolean
  Return TJO.RunMethod("isCustomFontEnabled",Null)
End Sub
'Returns true if the date of the clock will be drawn.
Public Sub IsDateVisible As Boolean
  Return TJO.RunMethod("isDateVisible",Null)
End Sub
'Returns true if the hour hand of the clock should move in discrete steps of 1 hour.
Public Sub IsDiscreteHours As Boolean
  Return TJO.RunMethod("isDiscreteHours",Null)
End Sub
'Returns true if the minute hand of the clock should move in discrete steps of 1 minute.
Public Sub IsDiscreteMinutes As Boolean
  Return TJO.RunMethod("isDiscreteMinutes",Null)
End Sub
'Returns true if the second hand of the clock should move in discrete steps of 1 second.
Public Sub IsDiscreteSeconds As Boolean
  Return TJO.RunMethod("isDiscreteSeconds",Null)
End Sub
'Returns true if a gradient defined by gradientStops will be used to fill the area in the SmoothAreaTileSkin.
Public Sub IsFillWithGradient As Boolean
  Return TJO.RunMethod("isFillWithGradient",Null)
End Sub
'Returns true if sections should be highlighted in case they contain the current value.
Public Sub IsHighlightSections As Boolean
  Return TJO.RunMethod("isHighlightSections",Null)
End Sub
'Returns true if the hour tickmarks will be drawn.
Public Sub IsHourTickMarksVisible As Boolean
  Return TJO.RunMethod("isHourTickMarksVisible",Null)
End Sub
'Returns true if an inner shadow should be drawn on the gauge background.
Public Sub IsInnerShadowEnabled As Boolean
  Return TJO.RunMethod("isInnerShadowEnabled",Null)
End Sub
'Returns true if the control should keep it's aspect.
Public Sub IsKeepAspect As Boolean
  Return TJO.RunMethod("isKeepAspect",Null)
End Sub
'Returns true if the indicator of the maxMeasuredValue is visible.
Public Sub IsMaxMeasuredValueVisible As Boolean
  Return TJO.RunMethod("isMaxMeasuredValueVisible",Null)
End Sub
'Returns true if the indicator of the minMeasuredValue is visible.
Public Sub IsMinMeasuredValueVisible As Boolean
  Return TJO.RunMethod("isMinMeasuredValueVisible",Null)
End Sub
'Returns true if the minute tickmarks will be drawn.
Public Sub IsMinuteTickMarksVisible As Boolean
  Return TJO.RunMethod("isMinuteTickMarksVisible",Null)
End Sub
'Returns true if the old value of the gauge is visible (not implemented)
Public Sub IsOldValueVisible As Boolean
  Return TJO.RunMethod("isOldValueVisible",Null)
End Sub
'Returns true if the needle/bar should always return to zero.
Public Sub IsReturnToZero As Boolean
  Return TJO.RunMethod("isReturnToZero",Null)
End Sub
'Returns true if the clock is running and shows the current time.
Public Sub IsRunning As Boolean
  Return TJO.RunMethod("isRunning",Null)
End Sub
'Returns true if the second hand of the clock will be drawn.
Public Sub IsSecondsVisible As Boolean
  Return TJO.RunMethod("isSecondsVisible",Null)
End Sub
'Returns true if the text of the sections should be drawn inside the sections.
Public Sub IsSectionTextVisible As Boolean
  Return TJO.RunMethod("isSectionTextVisible",Null)
End Sub
'Returns true if effects like shadows will be drawn.
Public Sub IsShadowsEnabled As Boolean
  Return TJO.RunMethod("isShadowsEnabled",Null)
End Sub
'Returns true when smoothing is enabled.
Public Sub IsSmoothing As Boolean
  Return TJO.RunMethod("isSmoothing",Null)
End Sub
'Gets the value of the property snapToTicks.
Public Sub IsSnapToTicks As Boolean
  Return TJO.RunMethod("isSnapToTicks",Null)
End Sub
'Gets the value of the property sortedData.
Public Sub IsSortedData As Boolean
  Return TJO.RunMethod("isSortedData",Null)
End Sub
'Returns true if the visualization of the value should start from 0.
Public Sub IsStartFromZero As Boolean
  Return TJO.RunMethod("isStartFromZero",Null)
End Sub
'Returns true if a gradient defined by gradientStops will be used to stroke the line in the SparklineTileSkin.
Public Sub IsStrokeWithGradient As Boolean
  Return TJO.RunMethod("isStrokeWithGradient",Null)
End Sub
'Returns true if the text of the clock will be drawn.
Public Sub IsTextVisible As Boolean
  Return TJO.RunMethod("isTextVisible",Null)
End Sub
'Returns true if the threshold indicator should be drawn.
Public Sub IsThresholdVisible As Boolean
  Return TJO.RunMethod("isThresholdVisible",Null)
End Sub
'Returns true if the visualization of the gauge value is visible.
Public Sub IsValueVisible As Boolean
  Return TJO.RunMethod("isValueVisible",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub KeepAspectProperty As JavaObject
  Return TJO.RunMethod("keepAspectProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub KnobColorProperty As JavaObject
  Return TJO.RunMethod("knobColorProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub LocaleProperty As JavaObject
  Return TJO.RunMethod("localeProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub MapProviderProperty As JavaObject
  Return TJO.RunMethod("mapProviderProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub MaxMeasuredValueProperty As JavaObject
  Return TJO.RunMethod("maxMeasuredValueProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub MaxMeasuredValueVisibleProperty As JavaObject
  Return TJO.RunMethod("maxMeasuredValueVisibleProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub MaxValueProperty As JavaObject
  Return TJO.RunMethod("maxValueProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub MinMeasuredValueProperty As JavaObject
  Return TJO.RunMethod("minMeasuredValueProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub MinMeasuredValueVisibleProperty As JavaObject
  Return TJO.RunMethod("minMeasuredValueVisibleProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub MinuteColorProperty As JavaObject
  Return TJO.RunMethod("minuteColorProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub MinuteTickMarkColorProperty As JavaObject
  Return TJO.RunMethod("minuteTickMarkColorProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub MinuteTickMarksVisibleProperty As JavaObject
  Return TJO.RunMethod("minuteTickMarksVisibleProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub MinValueProperty As JavaObject
  Return TJO.RunMethod("minValueProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub NeedleColorProperty As JavaObject
  Return TJO.RunMethod("needleColorProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub NumberFormatProperty As JavaObject
  Return TJO.RunMethod("numberFormatProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub OldValueProperty As JavaObject
  Return TJO.RunMethod("oldValueProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub OldValueVisibleProperty As JavaObject
  Return TJO.RunMethod("oldValueVisibleProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub OrientationProperty As JavaObject
  Return TJO.RunMethod("orientationProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub RadarChartModeProperty As JavaObject
  Return TJO.RunMethod("radarChartModeProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub RangeProperty As JavaObject
  Return TJO.RunMethod("rangeProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub ReferenceValueProperty As JavaObject
  Return TJO.RunMethod("referenceValueProperty",Null)
End Sub
'Removes the given Alarm object from the list of alarms.
Public Sub RemoveAlarm(ALARM As JavaObject)
  TJO.RunMethod("removeAlarm",Array As Object(ALARM))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub RemoveAlarmEventListener(Module As Object, EventName As String) As Object
  Dim Listeners As List
      Listeners.Initialize
      Dim LL As List = ListenersMap.Get("RemoveAlarmEventListener")
      If LL.IsInitialized Then Listeners.AddAll(LL)
  If Listeners.Size = 0 Then 
    Dim EventObject As Object = TJO.CreateEventFromUI("FullClassName", "Listener3" ,Null)
    TJO.RunMethod("removeAlarmEventListener",Array As Object(EventObject))
  End If
      'Depending on the type of listener, this code may not be needed, but is left here just in case.
      'It is safe to delete this and references to ListenerMap And Listenertype if they are not needed.
  Dim LT As ListenerType
  LT.Initialize
  LT.Module = Module
  LT.EventName = EventName
  Listeners.Add(LT)
  ListenersMap.Put("RemoveAlarmEventListener",Listeners)
  Return EventObject
End Sub
Private Sub Listener3_Event(MethodName As String,Args() As Object)
  Dim Listeners As List = ListenersMap.Get("RemoveAlarmEventListener")
  If Listeners.IsInitialized Then
    For Each LT As ListenerType In Listeners
      If SubExists(LT.Module, LT.EventName & "_Event") Then CallSub2(LT.Module, LT.EventName & "_Event",Args)
    Next
  End If
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub RemoveAllAlarmEventListeners
  TJO.RunMethod("removeAllAlarmEventListeners",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub RemoveAllTileEventListeners
  TJO.RunMethod("removeAllTileEventListeners",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub RemoveAllTimeEventListeners
  TJO.RunMethod("removeAllTimeEventListeners",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub RemoveBarChartItem(ITEM As BarChartItem)
  TJO.RunMethod("removeBarChartItem",Array As Object(ITEM.GetObject))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub RemoveChartData(DATA As JavaObject)
  TJO.RunMethod("removeChartData",Array As Object(DATA))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub RemoveLeaderBoardItem(ITEM As JavaObject)
  TJO.RunMethod("removeLeaderBoardItem",Array As Object(ITEM))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub RemoveOnSwitchPressed(Module As Object, EventName As String) As Object
  Dim Listeners As List
      Listeners.Initialize
      Dim LL As List = ListenersMap.Get("RemoveOnSwitchPressed")
      If LL.IsInitialized Then Listeners.AddAll(LL)
  If Listeners.Size = 0 Then 
    Dim EventObject As Object = TJO.CreateEventFromUI("FullClassName", "Listener4" ,Null)
    TJO.RunMethod("removeOnSwitchPressed",Array As Object(EventObject))
  End If
      'Depending on the type of listener, this code may not be needed, but is left here just in case.
      'It is safe to delete this and references to ListenerMap And Listenertype if they are not needed.
  Dim LT As ListenerType
  LT.Initialize
  LT.Module = Module
  LT.EventName = EventName
  Listeners.Add(LT)
  ListenersMap.Put("RemoveOnSwitchPressed",Listeners)
  Return EventObject
End Sub
Private Sub Listener4_Event(MethodName As String,Args() As Object)
  Dim Listeners As List = ListenersMap.Get("RemoveOnSwitchPressed")
  If Listeners.IsInitialized Then
    For Each LT As ListenerType In Listeners
      If SubExists(LT.Module, LT.EventName & "_Event") Then CallSub2(LT.Module, LT.EventName & "_Event",Args)
    Next
  End If
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub RemoveOnSwitchReleased(Module As Object, EventName As String) As Object
  Dim Listeners As List
      Listeners.Initialize
      Dim LL As List = ListenersMap.Get("RemoveOnSwitchReleased")
      If LL.IsInitialized Then Listeners.AddAll(LL)
  If Listeners.Size = 0 Then 
    Dim EventObject As Object = TJO.CreateEventFromUI("FullClassName", "Listener5" ,Null)
    TJO.RunMethod("removeOnSwitchReleased",Array As Object(EventObject))
  End If
      'Depending on the type of listener, this code may not be needed, but is left here just in case.
      'It is safe to delete this and references to ListenerMap And Listenertype if they are not needed.
  Dim LT As ListenerType
  LT.Initialize
  LT.Module = Module
  LT.EventName = EventName
  Listeners.Add(LT)
  ListenersMap.Put("RemoveOnSwitchReleased",Listeners)
  Return EventObject
End Sub
Private Sub Listener5_Event(MethodName As String,Args() As Object)
  Dim Listeners As List = ListenersMap.Get("RemoveOnSwitchReleased")
  If Listeners.IsInitialized Then
    For Each LT As ListenerType In Listeners
      If SubExists(LT.Module, LT.EventName & "_Event") Then CallSub2(LT.Module, LT.EventName & "_Event",Args)
    Next
  End If
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub RemovePoiLocation(TLOCATION As JavaObject)
  TJO.RunMethod("removePoiLocation",Array As Object(TLOCATION))
End Sub
'Removes the given Section from the list of sections.
Public Sub RemoveSection(TSECTION As Section)
  TJO.RunMethod("removeSection",Array As Object(TSECTION.GetObject))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub RemoveSeries(SERIES As JavaObject)
  TJO.RunMethod("removeSeries",Array As Object(SERIES))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub RemoveTileEventListener(Module As Object, EventName As String) As Object
  Dim Listeners As List
      Listeners.Initialize
      Dim LL As List = ListenersMap.Get("RemoveTileEventListener")
      If LL.IsInitialized Then Listeners.AddAll(LL)
  If Listeners.Size = 0 Then 
    Dim EventObject As Object = TJO.CreateEventFromUI("FullClassName", "Listener6" ,Null)
    TJO.RunMethod("removeTileEventListener",Array As Object(EventObject))
  End If
      'Depending on the type of listener, this code may not be needed, but is left here just in case.
      'It is safe to delete this and references to ListenerMap And Listenertype if they are not needed.
  Dim LT As ListenerType
  LT.Initialize
  LT.Module = Module
  LT.EventName = EventName
  Listeners.Add(LT)
  ListenersMap.Put("RemoveTileEventListener",Listeners)
  Return EventObject
End Sub
Private Sub Listener6_Event(MethodName As String,Args() As Object)
  Dim Listeners As List = ListenersMap.Get("RemoveTileEventListener")
  If Listeners.IsInitialized Then
    For Each LT As ListenerType In Listeners
      If SubExists(LT.Module, LT.EventName & "_Event") Then CallSub2(LT.Module, LT.EventName & "_Event",Args)
    Next
  End If
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub RemoveTilesFXSeries(SERIES As TilesFXSeries)
  TJO.RunMethod("removeTilesFXSeries",Array As Object(SERIES.GetObject))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub RemoveTimeEventListener(Module As Object, EventName As String) As Object
  Dim Listeners As List
      Listeners.Initialize
      Dim LL As List = ListenersMap.Get("RemoveTimeEventListener")
      If LL.IsInitialized Then Listeners.AddAll(LL)
  If Listeners.Size = 0 Then 
    Dim EventObject As Object = TJO.CreateEventFromUI("FullClassName", "Listener7" ,Null)
    TJO.RunMethod("removeTimeEventListener",Array As Object(EventObject))
  End If
      'Depending on the type of listener, this code may not be needed, but is left here just in case.
      'It is safe to delete this and references to ListenerMap And Listenertype if they are not needed.
  Dim LT As ListenerType
  LT.Initialize
  LT.Module = Module
  LT.EventName = EventName
  Listeners.Add(LT)
  ListenersMap.Put("RemoveTimeEventListener",Listeners)
  Return EventObject
End Sub
Private Sub Listener7_Event(MethodName As String,Args() As Object)
  Dim Listeners As List = ListenersMap.Get("RemoveTimeEventListener")
  If Listeners.IsInitialized Then
    For Each LT As ListenerType In Listeners
      If SubExists(LT.Module, LT.EventName & "_Event") Then CallSub2(LT.Module, LT.EventName & "_Event",Args)
    Next
  End If
End Sub
'Removes the given TimeSection from the list of sections.
Public Sub RemoveTimeSection(TSECTION As TimeSection)
  TJO.RunMethod("removeTimeSection",Array As Object(TSECTION.GetObject))
End Sub
'Resets the min- and maxMeasuredValue to the value of the gauge.
Public Sub ResetMeasuredValues
  TJO.RunMethod("resetMeasuredValues",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub ReturnToZeroProperty As JavaObject
  Return TJO.RunMethod("returnToZeroProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub RoundedCornersProperty As JavaObject
  Return TJO.RunMethod("roundedCornersProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub RunningProperty As JavaObject
  Return TJO.RunMethod("runningProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SecondColorProperty As JavaObject
  Return TJO.RunMethod("secondColorProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SecondsVisibleProperty As JavaObject
  Return TJO.RunMethod("secondsVisibleProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SectionIconsVisibleProperty As JavaObject
  Return TJO.RunMethod("sectionIconsVisibleProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SectionsAlwaysVisibleProperty As JavaObject
  Return TJO.RunMethod("sectionsAlwaysVisibleProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SectionsVisibleProperty As JavaObject
  Return TJO.RunMethod("sectionsVisibleProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SectionTextVisibleProperty As JavaObject
  Return TJO.RunMethod("sectionTextVisibleProperty",Null)
End Sub
'Defines if the switch in the SwitchTileSkin is active
Public Sub SetActive(SELECTED As Boolean)
  TJO.RunMethod("setActive",Array As Object(SELECTED))
End Sub
'Sets the value of the property activeColor.
Public Sub SetActiveColor(Color As Paint)
  TJO.RunMethod("setActiveColor",Array As Object(COLOR))
End Sub
'Defines the color that will be used to colorize the alarm icon
Public Sub SetAlarmColor(Color As Paint)
  TJO.RunMethod("setAlarmColor",Array As Object(COLOR))
End Sub
'Sets the alarms to the given array of Alarm objects.
Public Sub SetAlarms(ALARMS() As JavaObject)
  TJO.RunMethod("setAlarms",Array As Object( UnWrapTypedArray(ALARMS, "Please add class definition for Alarm to Array Types")))
End Sub
'Sets the alarms to the given list of Alarm objects.
Public Sub SetAlarms2(ALARMS As List)
  TJO.RunMethod("setAlarms",Array As Object(ALARMS))
End Sub
'Defines if alarms are enabled.
Public Sub SetAlarmsEnabled(CHECK As Boolean)
  TJO.RunMethod("setAlarmsEnabled",Array As Object(CHECK))
End Sub
'Defines if alarm markers should be drawn.
Public Sub SetAlarmsVisible(VISIBLE As Boolean)
  TJO.RunMethod("setAlarmsVisible",Array As Object(VISIBLE))
End Sub
'Defines if the alert property should be set.
Public Sub SetAlert(ALERT As Boolean)
  TJO.RunMethod("setAlert",Array As Object(ALERT))
End Sub
'Defines the text that could be used in a tooltip as an alert message.
Public Sub SetAlertMessage(MESSAGE As String)
  TJO.RunMethod("setAlertMessage",Array As Object(MESSAGE))
End Sub
'Defines the angle range in degree that will be used to draw the scale of the radial gauge.
Public Sub SetAngleRange(RANGE As Double)
  TJO.RunMethod("setAngleRange",Array As Object(RANGE))
End Sub
'Defines if setting the value of the gauge should be animated using the duration defined in animationDuration [ms].
Public Sub SetAnimated(ANIMATED As Boolean)
  TJO.RunMethod("setAnimated",Array As Object(ANIMATED))
End Sub
'Defines the duration An milliseconds that will be used to animate the needle/bar of the gauge from the last value to the next value.
Public Sub SetAnimationDuration(ANIMATION_DURATION As Long)
  TJO.RunMethod("setAnimationDuration",Array As Object(ANIMATION_DURATION))
End Sub
'Defines if the reference value for the StockTileSkin should be calculated automatically
Public Sub SetAutoReferenceValue(AUTO_REFERENCE_VALUE As Boolean)
  TJO.RunMethod("setAutoReferenceValue",Array As Object(AUTO_REFERENCE_VALUE))
End Sub
'Defines if the scale should be calculated automatically based on the defined values for min- and maxValue.
Public Sub SetAutoScale(AUTO_SCALE As Boolean)
  TJO.RunMethod("setAutoScale",Array As Object(AUTO_SCALE))
End Sub
'Defines if the average indicator should be drawn
Public Sub SetAverageVisible(VISIBLE As Boolean)
  TJO.RunMethod("setAverageVisible",Array As Object(VISIBLE))
End Sub
'Defines if the averaging functionality will be enabled.
Public Sub SetAveragingEnabled(ENABLED As Boolean)
  TJO.RunMethod("setAveragingEnabled",Array As Object(ENABLED))
End Sub
'Defines the number values that should be used for the averaging of values.
Public Sub SetAveragingPeriod(PERIOD As Int)
  TJO.RunMethod("setAveragingPeriod",Array As Object(PERIOD))
End Sub
'Defines the Paint object that will be used to fill the gauge background.
Public Sub SetBackgroundColor(Color As Paint)
  TJO.RunMethod("setBackgroundColor",Array As Object(COLOR))
End Sub
'Returns the color that will be used to colorize the bar background of the gauge (if it has a bar).
Public Sub SetBarBackgroundColor(Color As Paint)
  TJO.RunMethod("setBarBackgroundColor",Array As Object(COLOR))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetBarChartItems(ITEMS() As BarChartItem)
  TJO.RunMethod("setBarChartItems",Array As Object( UnWrapTypedArray(ITEMS, "Please add class definition for BarChartItem to Array Types")))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetBarChartItems2(ITEMS As List)
  TJO.RunMethod("setBarChartItems",Array As Object(ITEMS))
End Sub
'Defines the color that will be used to colorize the bar of the gauge (if it has a bar).
Public Sub SetBarColor(Color As Paint)
  TJO.RunMethod("setBarColor",Array As Object(COLOR))
End Sub
'Defines the Paint object that will be used to draw the border of the gauge.
Public Sub SetBorderColor(PAINT As JavaObject)
  TJO.RunMethod("setBorderColor",Array As Object(PAINT))
End Sub
'Defines the width in pixels that will be used to draw the border of the gauge.
Public Sub SetBorderWidth(WIDTH As Double)
  TJO.RunMethod("setBorderWidth",Array As Object(WIDTH))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetCharacters(CHARACTERS() As String)
  TJO.RunMethod("setCharacters",Array As Object( UnWrapTypedArray(CHARACTERS, "Please add class definition for java.lang.String to Array Types")))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetChartData(DATA() As JavaObject)
  TJO.RunMethod("setChartData",Array As Object( UnWrapTypedArray(DATA, "Please add class definition for ChartData to Array Types")))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetChartData2(DATA As List)
  TJO.RunMethod("setChartData",Array As Object(DATA))
End Sub
'Defines the color that will be used to colorize lines in charts e.g.
Public Sub SetChartGridColor(Color As Paint)
  TJO.RunMethod("setChartGridColor",Array As Object(Color))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetChartType(TTYPE As JavaObject)
  TJO.RunMethod("setChartType",Array As Object(TTYPE))
End Sub
'Defines if the value of the gauge should be checked against all sections (if sections not empty).
Public Sub SetCheckSectionsForValue(CHECK As Boolean)
  TJO.RunMethod("setCheckSectionsForValue",Array As Object(CHECK))
End Sub
'Defines if the value of the gauge should be checked against the threshold.
Public Sub SetCheckThreshold(CHECK As Boolean)
  TJO.RunMethod("setCheckThreshold",Array As Object(CHECK))
End Sub
'Defines the Locale that will be used to visualize the country in the CountryTileSkin
Public Sub SetCountry(TCOUNTRY As Country)
  TJO.RunMethod("setCountry",Array As Object(TCOUNTRY.GetObject))
End Sub
'Sets the value of the property countryGroup.
Public Sub SetCountryGroup(GROUP As JavaObject)
  TJO.RunMethod("setCountryGroup",Array As Object(GROUP))
End Sub
'Sets the value of the property currentLocation.
Public Sub SetCurrentLocation(TLOCATION As Location)
  TJO.RunMethod("setCurrentLocation",Array As Object(TLOCATION.GetObject))
End Sub
'Defines the custom font that can be used to render all text elements.
Public Sub SetCustomFont(TFONT As Font)
  TJO.RunMethod("setCustomFont",Array As Object(TFONT))
End Sub
'Defines if the control should use the given customFont to render all text elements
Public Sub SetCustomFontEnabled(ENABLED As Boolean)
  TJO.RunMethod("setCustomFontEnabled",Array As Object(ENABLED))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetDarkSky(DARK_SKY As JavaObject)
  TJO.RunMethod("setDarkSky",Array As Object(DARK_SKY))
End Sub
'Sets the value of the property dataPointsVisible.
Public Sub SetDataPointsVisible(VISIBLE As Boolean)
  TJO.RunMethod("setDataPointsVisible",Array As Object(VISIBLE))
End Sub
'Defines the color that will be used to colorize the date of the clock
Public Sub SetDateColor(Color As Paint)
  TJO.RunMethod("setDateColor",Array As Object(Color))
End Sub
'Defines if the date of the clock will be drawn.
Public Sub SetDateVisible(VISIBLE As Boolean)
  TJO.RunMethod("setDateVisible",Array As Object(VISIBLE))
End Sub
'Defines the number of decimals that will be used to format the value of the gauge.
Public Sub SetDecimals(DECIMALS As Int)
  TJO.RunMethod("setDecimals",Array As Object(DECIMALS))
End Sub
'Sets the description text of the gauge.
Public Sub SetDescription(DESCRIPTION As String)
  TJO.RunMethod("setDescription",Array As Object(DESCRIPTION))
End Sub
'Defines the alignment of the description text (esp.
Public Sub SetDescriptionAlignment(ALIGNMENT As JavaObject)
  TJO.RunMethod("setDescriptionAlignment",Array As Object(ALIGNMENT))
End Sub
'Defines the color that will be used to colorize the description text of the gauge.
Public Sub SetDescriptionColor(Color As Paint)
  TJO.RunMethod("setDescriptionColor",Array As Object(Color))
End Sub
'Defines if the hour hand of the clock should move in discrete steps of 1 hour.
Public Sub SetDiscreteHours(DISCRETE As Boolean)
  TJO.RunMethod("setDiscreteHours",Array As Object(DISCRETE))
End Sub
'Defines if the minute hand of the clock should move in discrete steps of 1 minute.
Public Sub SetDiscreteMinutes(DISCRETE As Boolean)
  TJO.RunMethod("setDiscreteMinutes",Array As Object(DISCRETE))
End Sub
'Defines if the second hand of the clock should move in discrete steps of 1 second.
Public Sub SetDiscreteSeconds(DISCRETE As Boolean)
  TJO.RunMethod("setDiscreteSeconds",Array As Object(DISCRETE))
End Sub
'Defines a duration that is used in the TimeTileSkin
Public Sub SetDuration(DURATION As JavaObject)
  TJO.RunMethod("setDuration",Array As Object(DURATION))
End Sub
'Defines the usage of a gradient defined by gradientStops to fill the area in the SmoothAreaTileSkin
Public Sub SetFillWithGradient(FILL_WITH_GRADIENT As Boolean)
  TJO.RunMethod("setFillWithGradient",Array As Object(FILL_WITH_GRADIENT))
End Sub
'Defines the text that will be used to visualize the FlipTileSkin
Public Sub SetFlipText(TEXT As String)
  TJO.RunMethod("setFlipText",Array As Object(TEXT))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetFlipTimeInMS(FLIP_TIME As Long)
  TJO.RunMethod("setFlipTimeInMS",Array As Object(FLIP_TIME))
End Sub
'A convenient method to set the color of foreground elements like title, description, unit, value, tickLabel and tickMark to the given Color.
Public Sub SetForegroundBaseColor(Color As Paint)
  TJO.RunMethod("setForegroundBaseColor",Array As Object(Color))
End Sub
'Defines the Paint object that will be used to fill the gauge foreground.
Public Sub SetForegroundColor(Color As Paint)
  TJO.RunMethod("setForegroundColor",Array As Object(Color))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetGradientStops(STOPS As List)
  TJO.RunMethod("setGradientStops",Array As Object(STOPS))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetGradientStops2(STOPS() As JavaObject)
  TJO.RunMethod("setGradientStops",Array As Object( UnWrapTypedArray(STOPS, "Please add class definition for javafx.scene.paint.Stop to Array Types")))
End Sub
'Defines an optional node that can be used in combination with the CustomTileSkin.
Public Sub SetGraphic(GRAPHIC As Node)
  TJO.RunMethod("setGraphic",Array As Object(GRAPHIC))
End Sub
'Defines if sections should be highlighted in case they contain the current value
Public Sub SetHighlightSections(HIGHLIGHT As Boolean)
  TJO.RunMethod("setHighlightSections",Array As Object(HIGHLIGHT))
End Sub
'Defines the color that will be used to colorize the hour hand of the clock
Public Sub SetHourColor(Color As Paint)
  TJO.RunMethod("setHourColor",Array As Object(Color))
End Sub
'Defines the color that will be used to colorize the hour tickmarks of the clock.
Public Sub SetHourTickMarkColor(Color As Paint)
  TJO.RunMethod("setHourTickMarkColor",Array As Object(Color))
End Sub
'Defines if the hour tickmarks will be drawn.
Public Sub SetHourTickMarksVisible(VISIBLE As Boolean)
  TJO.RunMethod("setHourTickMarksVisible",Array As Object(VISIBLE))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetIncrement(INCREMENT As Double)
  TJO.RunMethod("setIncrement",Array As Object(INCREMENT))
End Sub
'Defines if an inner shadow should be drawn on the gauge background.
Public Sub SetInnerShadowEnabled(ENABLED As Boolean)
  TJO.RunMethod("setInnerShadowEnabled",Array As Object(ENABLED))
End Sub
'Defines if the control should keep it's aspect.
Public Sub SetKeepAspect(KEEP As Boolean)
  TJO.RunMethod("setKeepAspect",Array As Object(KEEP))
End Sub
'Defines the color that will be used to colorize the knob of the radial gauges.
Public Sub SetKnobColor(Color As Paint)
  TJO.RunMethod("setKnobColor",Array As Object(Color))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetLeaderBoardItems(ITEMS As List)
  TJO.RunMethod("setLeaderBoardItems",Array As Object(ITEMS))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetLeaderBoardItems2(ITEMS() As JavaObject)
  TJO.RunMethod("setLeaderBoardItems",Array As Object( UnWrapTypedArray(ITEMS, "Please add class definition for LeaderBoardItem to Array Types")))
End Sub
'Sets the value of the property locale.
Public Sub SetLocale(LOCALE As JavaObject)
  TJO.RunMethod("setLocale",Array As Object(LOCALE))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetMajorTickUnit(MAJOR_TICK_UNIT As Double)
  TJO.RunMethod("setMajorTickUnit",Array As Object(MAJOR_TICK_UNIT))
End Sub
'Sets the value of the property mapProvider.
Public Sub SetMapProvider(PROVIDER As JavaObject)
  TJO.RunMethod("setMapProvider",Array As Object(PROVIDER))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetMatrixSize(COLUMNS As Int, ROWS As Int)
  TJO.RunMethod("setMatrixSize",Array As Object(COLUMNS, ROWS))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetMatrixSize2(COLUMNS_AND_ROWS() As Int)
  TJO.RunMethod("setMatrixSize",Array As Object(COLUMNS_AND_ROWS))
End Sub
'Sets the maxMeasuredVAlue to the given value.
Public Sub SetMaxMeasuredValue(MAX_MEASURED_VALUE As Double)
  TJO.RunMethod("setMaxMeasuredValue",Array As Object(MAX_MEASURED_VALUE))
End Sub
'Defines if the indicator of the maxMeasuredValue should be visible.
Public Sub SetMaxMeasuredValueVisible(VISIBLE As Boolean)
  TJO.RunMethod("setMaxMeasuredValueVisible",Array As Object(VISIBLE))
End Sub
'Sets the maximum value of the gauge scale to the given value
Public Sub SetMaxValue(VALUE As Double)
  TJO.RunMethod("setMaxValue",Array As Object(VALUE))
End Sub
'Sets the minMeasuredValue to the given value.
Public Sub SetMinMeasuredValue(MIN_MEASURED_VALUE As Double)
  TJO.RunMethod("setMinMeasuredValue",Array As Object(MIN_MEASURED_VALUE))
End Sub
'Defines if the indicator of the minMeasuredValue should be visible.
Public Sub SetMinMeasuredValueVisible(VISIBLE As Boolean)
  TJO.RunMethod("setMinMeasuredValueVisible",Array As Object(VISIBLE))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetMinorTickCount(MINOR_TICK_COUNT As Int)
  TJO.RunMethod("setMinorTickCount",Array As Object(MINOR_TICK_COUNT))
End Sub
'Defines the color that will be used to colorize the minute hand of the clock.
Public Sub SetMinuteColor(Color As Paint)
  TJO.RunMethod("setMinuteColor",Array As Object(COLOR))
End Sub
'Defines the color that will be used to colorize the minute tickmarks of the clock.
Public Sub SetMinuteTickMarkColor(Color As Paint)
  TJO.RunMethod("setMinuteTickMarkColor",Array As Object(COLOR))
End Sub
'Defines if the minute tickmarks will be drawn.
Public Sub SetMinuteTickMarksVisible(VISIBLE As Boolean)
  TJO.RunMethod("setMinuteTickMarksVisible",Array As Object(VISIBLE))
End Sub
'Sets the minimum value of the gauge scale to the given value
Public Sub SetMinValue(VALUE As Double)
  TJO.RunMethod("setMinValue",Array As Object(VALUE))
End Sub
'Defines the color that will be used to colorize the needle of the radial gauges.
Public Sub SetNeedleColor(Color As Paint)
  TJO.RunMethod("setNeedleColor",Array As Object(COLOR))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetNotificationBackgroundColor(Color As Paint)
  TJO.RunMethod("setNotificationBackgroundColor",Array As Object(COLOR))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetNotificationForegroundColor(Color As Paint)
  TJO.RunMethod("setNotificationForegroundColor",Array As Object(COLOR))
End Sub
'Defines the number format that will be used to format the value in the gauge (NOT USED AT THE MOMENT)
Public Sub SetNumberFormat(FORMAT As JavaObject)
  TJO.RunMethod("setNumberFormat",Array As Object(FORMAT))
End Sub
'Defines if the old value of the gauge should be visible (not implemented)
Public Sub SetOldValueVisible(VISIBLE As Boolean)
  TJO.RunMethod("setOldValueVisible",Array As Object(VISIBLE))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetOnAlarm(Module As Object, EventName As String) As Object
  Dim Listeners As List
      Listeners.Initialize
      Dim LL As List = ListenersMap.Get("SetOnAlarm")
      If LL.IsInitialized Then Listeners.AddAll(LL)
  If Listeners.Size = 0 Then 
    Dim EventObject As Object = TJO.CreateEventFromUI("FullClassName", "Listener8" ,Null)
    TJO.RunMethod("setOnAlarm",Array As Object(EventObject))
  End If
      'Depending on the type of listener, this code may not be needed, but is left here just in case.
      'It is safe to delete this and references to ListenerMap And Listenertype if they are not needed.
  Dim LT As ListenerType
  LT.Initialize
  LT.Module = Module
  LT.EventName = EventName
  Listeners.Add(LT)
  ListenersMap.Put("SetOnAlarm",Listeners)
  Return EventObject
End Sub
Private Sub Listener8_Event(MethodName As String,Args() As Object)
  Dim Listeners As List = ListenersMap.Get("SetOnAlarm")
  If Listeners.IsInitialized Then
    For Each LT As ListenerType In Listeners
      If SubExists(LT.Module, LT.EventName & "_Event") Then CallSub2(LT.Module, LT.EventName & "_Event",Args)
    Next
  End If
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetOnSwitchPressed(Module As Object, EventName As String) As Object
  Dim Listeners As List
      Listeners.Initialize
      Dim LL As List = ListenersMap.Get("SetOnSwitchPressed")
      If LL.IsInitialized Then Listeners.AddAll(LL)
  If Listeners.Size = 0 Then 
    Dim EventObject As Object = TJO.CreateEventFromUI("FullClassName", "Listener9" ,Null)
    TJO.RunMethod("setOnSwitchPressed",Array As Object(EventObject))
  End If
      'Depending on the type of listener, this code may not be needed, but is left here just in case.
      'It is safe to delete this and references to ListenerMap And Listenertype if they are not needed.
  Dim LT As ListenerType
  LT.Initialize
  LT.Module = Module
  LT.EventName = EventName
  Listeners.Add(LT)
  ListenersMap.Put("SetOnSwitchPressed",Listeners)
  Return EventObject
End Sub
Private Sub Listener9_Event(MethodName As String,Args() As Object)
  Dim Listeners as List = ListenersMap.Get("SetOnSwitchPressed")
  If Listeners.IsInitialized Then
    For Each LT As ListenerType In Listeners
      If SubExists(LT.Module, LT.EventName & "_Event") Then CallSub2(LT.Module, LT.EventName & "_Event",Args)
    Next
  End If
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetOnSwitchReleased(Module As Object, EventName As String) As Object
  Dim Listeners as List
      Listeners.Initialize
      Dim LL as List = ListenersMap.Get("SetOnSwitchReleased")
      If LL.IsInitialized Then Listeners.AddAll(LL)
  If Listeners.Size = 0 Then 
    Dim EventObject As Object = TJO.CreateEventFromUI("FullClassName", "Listener10" ,Null)
    TJO.RunMethod("setOnSwitchReleased",Array As Object(EventObject))
  End If
      'Depending on the type of listener, this code may not be needed, but is left here just in case.
      'It is safe to delete this and references to ListenerMap And Listenertype if they are not needed.
  Dim LT As ListenerType
  LT.Initialize
  LT.Module = Module
  LT.EventName = EventName
  Listeners.Add(LT)
  ListenersMap.Put("SetOnSwitchReleased",Listeners)
  Return EventObject
End Sub
Private Sub Listener10_Event(MethodName As String,Args() As Object)
  Dim Listeners as List = ListenersMap.Get("SetOnSwitchReleased")
  If Listeners.IsInitialized Then
    For Each LT As ListenerType In Listeners
      If SubExists(LT.Module, LT.EventName & "_Event") Then CallSub2(LT.Module, LT.EventName & "_Event",Args)
    Next
  End If
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetOnTileEvent(Module As Object, EventName As String) As Object
  Dim Listeners as List
      Listeners.Initialize
      Dim LL as List = ListenersMap.Get("SetOnTileEvent")
      If LL.IsInitialized Then Listeners.AddAll(LL)
  If Listeners.Size = 0 Then 
    Dim EventObject As Object = TJO.CreateEventFromUI("FullClassName", "Listener11" ,Null)
    TJO.RunMethod("setOnTileEvent",Array As Object(EventObject))
  End If
      'Depending on the type of listener, this code may not be needed, but is left here just in case.
      'It is safe to delete this and references to ListenerMap And Listenertype if they are not needed.
  Dim LT As ListenerType
  LT.Initialize
  LT.Module = Module
  LT.EventName = EventName
  Listeners.Add(LT)
  ListenersMap.Put("SetOnTileEvent",Listeners)
  Return EventObject
End Sub
Private Sub Listener11_Event(MethodName As String,Args() As Object)
  Dim Listeners as List = ListenersMap.Get("SetOnTileEvent")
  If Listeners.IsInitialized Then
    For Each LT As ListenerType In Listeners
      If SubExists(LT.Module, LT.EventName & "_Event") Then CallSub2(LT.Module, LT.EventName & "_Event",Args)
    Next
  End If
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetOnTimeEvent(Module As Object, EventName As String) As Object
  Dim Listeners As List
      Listeners.Initialize
      Dim LL As List = ListenersMap.Get("SetOnTimeEvent")
      If LL.IsInitialized Then Listeners.AddAll(LL)
  If Listeners.Size = 0 Then 
    Dim EventObject As Object = TJO.CreateEventFromUI("FullClassName", "Listener12" ,Null)
    TJO.RunMethod("setOnTimeEvent",Array As Object(EventObject))
  End If
      'Depending on the type of listener, this code may not be needed, but is left here just in case.
      'It is safe to delete this and references to ListenerMap And Listenertype if they are not needed.
  Dim LT As ListenerType
  LT.Initialize
  LT.Module = Module
  LT.EventName = EventName
  Listeners.Add(LT)
  ListenersMap.Put("SetOnTimeEvent",Listeners)
  Return EventObject
End Sub
Private Sub Listener12_Event(MethodName As String,Args() As Object)
  Dim Listeners As List = ListenersMap.Get("SetOnTimeEvent")
  If Listeners.IsInitialized Then
    For Each LT As ListenerType In Listeners
      If SubExists(LT.Module, LT.EventName & "_Event") Then CallSub2(LT.Module, LT.EventName & "_Event",Args)
    Next
  End If
End Sub
'Defines the orientation of the control.
Public Sub SetOrientation(ORIENTATION As JavaObject)
  TJO.RunMethod("setOrientation",Array As Object(ORIENTATION))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetPoiList(POI_LIST As List)
  TJO.RunMethod("setPoiList",Array As Object(POI_LIST))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetPoiLocations(LOCATIONS() As JavaObject)
  TJO.RunMethod("setPoiLocations",Array As Object( UnWrapTypedArray(LOCATIONS, "Please add class definition for Location to Array Types")))
End Sub
'Defines the mode that is used in the RadarChartTileSkin to visualize the data in the RadarChart.
Public Sub SetRadarChartMode(MODE As JavaObject)
  TJO.RunMethod("setRadarChartMode",Array As Object(MODE))
End Sub
'Defines the reference value that will be used in the HighLowTileSkin
Public Sub SetReferenceValue(VALUE As Double)
  TJO.RunMethod("setReferenceValue",Array As Object(VALUE))
End Sub
'Defines the behavior of the visualization where the needle/bar should always return to 0 after it reached the final value.
Public Sub SetReturnToZero(IS_TRUE As Boolean)
  TJO.RunMethod("setReturnToZero",Array As Object(IS_TRUE))
End Sub
'Switches the corners of the Tiles between rounded and rectangular
Public Sub SetRoundedCorners(ROUNDED As Boolean)
  TJO.RunMethod("setRoundedCorners",Array As Object(ROUNDED))
End Sub
'Defines if the clock is running.
Public Sub SetRunning(RUNNING As Boolean)
  TJO.RunMethod("setRunning",Array As Object(RUNNING))
End Sub
'Defines the color that will be used to colorize the second hand of the clock
Public Sub SetSecondColor(Color As Paint)
  TJO.RunMethod("setSecondColor",Array As Object(Color))
End Sub
'Defines if the second hand of the clock will be drawn.
Public Sub SetSecondsVisible(VISIBLE As Boolean)
  TJO.RunMethod("setSecondsVisible",Array As Object(VISIBLE))
End Sub
'Defines if the icon of the sections should be drawn inside the sections.
Public Sub SetSectionIconsVisible(VISIBLE As Boolean)
  TJO.RunMethod("setSectionIconsVisible",Array As Object(VISIBLE))
End Sub
'Sets the sections to the given list of Section objects.
Public Sub SetSections(SECTIONS As List)
  TJO.RunMethod("setSections",Array As Object(SECTIONS))
End Sub
'Sets the sections to the given array of Section objects.
Public Sub SetSections2(SECTIONS() As Section)
  TJO.RunMethod("setSections",Array As Object( UnWrapTypedArray(SECTIONS, "Please add class definition for Section to Array Types")))
End Sub
'Defines if the sections will always be visible.
Public Sub SetSectionsAlwaysVisible(VISIBLE As Boolean)
  TJO.RunMethod("setSectionsAlwaysVisible",Array As Object(VISIBLE))
End Sub
'Defines if the sections will be drawn
Public Sub SetSectionsVisible(VISIBLE As Boolean)
  TJO.RunMethod("setSectionsVisible",Array As Object(VISIBLE))
End Sub
'Defines if the text of the sections should be drawn inside the sections.
Public Sub SetSectionTextVisible(VISIBLE As Boolean)
  TJO.RunMethod("setSectionTextVisible",Array As Object(VISIBLE))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetSeries(SERIES As JavaObject)
  TJO.RunMethod("setSeries",Array As Object(SERIES))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetSeries2(SERIES() As JavaObject)
  TJO.RunMethod("setSeries",Array As Object( UnWrapTypedArray(SERIES, "Please add class definition for javafx.scene.chart.XYChart.Series to Array Types")))
End Sub
'Defines if effects like shadows should be drawn.
Public Sub SetShadowsEnabled(ENABLED As Boolean)
  TJO.RunMethod("setShadowsEnabled",Array As Object(ENABLED))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetSkinType(SKIN_TYPE As JavaObject)
  TJO.RunMethod("setSkinType",Array As Object(SKIN_TYPE))
End Sub
'Defines if the smoothing property should be enabled/disabled.
Public Sub SetSmoothing(SMOOTHING As Boolean)
  TJO.RunMethod("setSmoothing",Array As Object(SMOOTHING))
End Sub
'Sets the value of the property snapToTicks.
Public Sub SetSnapToTicks(SNAP As Boolean)
  TJO.RunMethod("setSnapToTicks",Array As Object(SNAP))
End Sub
'Sets the value of the property sortedData.
Public Sub SetSortedData(SORTED As Boolean)
  TJO.RunMethod("setSortedData",Array As Object(SORTED))
End Sub
'Defines the angle in degree that defines the start of the scale with it's minValue in a radial gauge.
Public Sub SetStartAngle(ANGLE As Double)
  TJO.RunMethod("setStartAngle",Array As Object(ANGLE))
End Sub
'Defines the behavior of the visualization where the needle/bar should start from 0 instead of the minValue.
Public Sub SetStartFromZero(IS_TRUE As Boolean)
  TJO.RunMethod("setStartFromZero",Array As Object(IS_TRUE))
End Sub
'Defines the usage of a gradient defined by gradientStops to stroke the line in the SparklineTileSkin
Public Sub SetStrokeWithGradient(STROKE_WITH_GRADIENT As Boolean)
  TJO.RunMethod("setStrokeWithGradient",Array As Object(STROKE_WITH_GRADIENT))
End Sub
'Define the text for the clock.
Public Sub SetText(TEXT As String)
  TJO.RunMethod("setText",Array As Object(TEXT))
End Sub
'Defines the alignment that will be used to align the text in the Tile.
Public Sub SetTextAlignment(ALIGNMENT As String)
  TJO.RunMethod("setTextAlignment",Array As Object(ALIGNMENT))
End Sub
'Defines the color that will be used to colorize the text of the clock.
Public Sub SetTextColor(Color As Paint)
  TJO.RunMethod("setTextColor",Array As Object(Color))
End Sub
'Defines the text size that will be used for the title, subtitle and text in the different skins.
Public Sub SetTextSize(SIZE As String)
  TJO.RunMethod("setTextSize",Array As Object(SIZE))
End Sub
'Defines if the text of the clock will be drawn.
Public Sub SetTextVisible(VISIBLE As Boolean)
  TJO.RunMethod("setTextVisible",Array As Object(VISIBLE))
End Sub
'Sets the threshold of the gauge to the given value.
Public Sub SetThreshold(THRESHOLD As Double)
  TJO.RunMethod("setThreshold",Array As Object(THRESHOLD))
End Sub
'Defines the color that will be used to colorize the threshold indicator of the gauge.
Public Sub SetThresholdColor(Color As Paint)
  TJO.RunMethod("setThresholdColor",Array As Object(Color))
End Sub
'Defines if the threshold indicator should be drawn
Public Sub SetThresholdVisible(VISIBLE As Boolean)
  TJO.RunMethod("setThresholdVisible",Array As Object(VISIBLE))
End Sub
'Defines the number of tickLabelDecimals that will be used to format the ticklabels of the gauge.
Public Sub SetTickLabelDecimals(DECIMALS As Int)
  TJO.RunMethod("setTickLabelDecimals",Array As Object(DECIMALS))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetTilesFXSeries(SERIES As JavaObject)
  TJO.RunMethod("setTilesFXSeries",Array As Object(SERIES))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetTilesFXSeries2(SERIES() As TilesFXSeries)
  TJO.RunMethod("setTilesFXSeries",Array As Object( UnWrapTypedArray(SERIES, "Please add class definition for TilesFXSeries to Array Types")))
End Sub
'Defines the current time of the clock.
Public Sub SetTime(TIME As JavaObject)
  TJO.RunMethod("setTime",Array As Object(TIME))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetTime2(EPOCH_SECONDS As Long)
  TJO.RunMethod("setTime",Array As Object(EPOCH_SECONDS))
End Sub
'Sets the sections to the given list of TimeSection objects.
Public Sub SetTimeSections(SECTIONS As List)
  TJO.RunMethod("setTimeSections",Array As Object(SECTIONS))
End Sub
'Sets the sections to the given array of TimeSection objects.
Public Sub SetTimeSections2(SECTIONS() As TimeSection)
  TJO.RunMethod("setTimeSections",Array As Object( UnWrapTypedArray(SECTIONS, "Please add class definition for TimeSection to Array Types")))
End Sub
'Sets the title of the gauge.
Public Sub SetTitle(TITLE As String)
  TJO.RunMethod("setTitle",Array As Object(TITLE))
End Sub
'Defines the alignment that will be used to align the title in the Tile.
Public Sub SetTitleAlignment(ALIGNMENT As String)
  TJO.RunMethod("setTitleAlignment",Array As Object(ALIGNMENT))
End Sub
'Defines the color that will be used to colorize the title of the gauge.
Public Sub SetTitleColor(Color As Paint)
  TJO.RunMethod("setTitleColor",Array As Object(Color))
End Sub
'Defines the text that will be shown in the Tile tooltip
Public Sub SetTooltipText(TEXT As String)
  TJO.RunMethod("setTooltipText",Array As Object(TEXT))
End Sub
'Sets the value of the property tooltipTimeout.
Public Sub SetTooltipTimeout(TIMEOUT As Double)
  TJO.RunMethod("setTooltipTimeout",Array As Object(TIMEOUT))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetTrack(LOCATIONS As List)
  TJO.RunMethod("setTrack",Array As Object(LOCATIONS))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SetTrack2(LOCATIONS() As JavaObject)
  TJO.RunMethod("setTrack",Array As Object( UnWrapTypedArray(LOCATIONS, "Please add class definition for Location to Array Types")))
End Sub
'Sets the value of the property trackColor.
Public Sub SetTrackColor(Color As Paint)
  TJO.RunMethod("setTrackColor",Array As Object(Color))
End Sub
'Sets the unit of the gauge.
Public Sub SetUnit(UNIT As String)
  TJO.RunMethod("setUnit",Array As Object(UNIT))
End Sub
'Defines the color that will be used to colorize the unit of the gauge.
Public Sub SetUnitColor(Color As Paint)
  TJO.RunMethod("setUnitColor",Array As Object(Color))
End Sub
'Sets the value of the Tile to the given double.
Public Sub SetValue(VALUE As Double)
  TJO.RunMethod("setValue",Array As Object(VALUE))
End Sub
'Defines the color that will be used to colorize the value of the gauge.
Public Sub SetValueColor(Color As Paint)
  TJO.RunMethod("setValueColor",Array As Object(Color))
End Sub
'Defines if the visualization of the gauge value should be visible.
Public Sub SetValueVisible(VISIBLE As Boolean)
  TJO.RunMethod("setValueVisible",Array As Object(VISIBLE))
End Sub
'Sets the value of the property xAxis.
Public Sub SetXAxis(AXIS As JavaObject)
  TJO.RunMethod("setXAxis",Array As Object(AXIS))
End Sub
'Sets the value of the property yAxis.
Public Sub SetYAxis(AXIS As JavaObject)
  TJO.RunMethod("setYAxis",Array As Object(AXIS))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub ShadowsEnabledProperty As JavaObject
  Return TJO.RunMethod("shadowsEnabledProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub ShowNotifyRegion(SHOW As Boolean)
  TJO.RunMethod("showNotifyRegion",Array As Object(SHOW))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SmoothingProperty As JavaObject
  Return TJO.RunMethod("smoothingProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SnapToTicksProperty As JavaObject
  Return TJO.RunMethod("snapToTicksProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub SortedDataProperty As JavaObject
  Return TJO.RunMethod("sortedDataProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub StartAngleProperty As JavaObject
  Return TJO.RunMethod("startAngleProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub StartFromZeroProperty As JavaObject
  Return TJO.RunMethod("startFromZeroProperty",Null)
End Sub
'Calling this method will stop all threads.
Public Sub Stop
  TJO.RunMethod("stop",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub StrokeWithGradientProperty As JavaObject
  Return TJO.RunMethod("strokeWithGradientProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub TextAlignmentProperty As JavaObject
  Return TJO.RunMethod("textAlignmentProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub TextColorProperty As JavaObject
  Return TJO.RunMethod("textColorProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub TextProperty As JavaObject
  Return TJO.RunMethod("textProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub TextSizeProperty As JavaObject
  Return TJO.RunMethod("textSizeProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub TextVisibleProperty As JavaObject
  Return TJO.RunMethod("textVisibleProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub ThresholdColorProperty As JavaObject
  Return TJO.RunMethod("thresholdColorProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub ThresholdVisibleProperty As JavaObject
  Return TJO.RunMethod("thresholdVisibleProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub TickLabelDecimalsProperty As JavaObject
  Return TJO.RunMethod("tickLabelDecimalsProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub TimeProperty As JavaObject
  Return TJO.RunMethod("timeProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub TitleAlignmentProperty As JavaObject
  Return TJO.RunMethod("titleAlignmentProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub TitleColorProperty As JavaObject
  Return TJO.RunMethod("titleColorProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub TitleProperty As JavaObject
  Return TJO.RunMethod("titleProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub TooltipTextProperty As JavaObject
  Return TJO.RunMethod("tooltipTextProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub TooltipTimeoutProperty As JavaObject
  Return TJO.RunMethod("tooltipTimeoutProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub TrackColorProperty As JavaObject
  Return TJO.RunMethod("trackColorProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub TresholdProperty As JavaObject
  Return TJO.RunMethod("tresholdProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub UnitColorProperty As JavaObject
  Return TJO.RunMethod("unitColorProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub UnitProperty As JavaObject
  Return TJO.RunMethod("unitProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub UpdateLocation(LATITUDE As Double, LONGITUDE As Double)
  TJO.RunMethod("updateLocation",Array As Object(LATITUDE, LONGITUDE))
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub UpdateWeather
  TJO.RunMethod("updateWeather",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub ValueColorProperty As JavaObject
  Return TJO.RunMethod("valueColorProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub ValueProperty As JavaObject
  Return TJO.RunMethod("valueProperty",Null)
End Sub
'MISSING COMMENT FOR THIS LINE
Public Sub ValueVisibleProperty As JavaObject
  Return TJO.RunMethod("valueVisibleProperty",Null)
End Sub
'javafx.beans.property.ObjectProperty<javafx.scene.chart.Axis>  yAxisProperty()
Public Sub XAxisProperty As JavaObject
  Return TJO.RunMethod("xAxisProperty",Null)
End Sub


'Set the Tag for this object
Public Sub SetTag(Tag As Object)
  TJO.RunMethod("setUserData",Array(Tag))
End Sub

'Get the Tag for this object
Public Sub GetTag As Object
  Dim Tag As Object = TJO.RunMethod("getUserData",Null)
  If Tag = Null Then Tag = ""
  Return Tag 
End Sub

'UnWrap a Wrapped array . 
'Arr is an array of wrapped objects
Private Sub UnWrapTypedArray(Arr As Object,UnWrapType As String) As Object
  Dim P1 As JavaObject
  Dim ObjArr() As Object = Arr
  Dim ResultArr(ObjArr.Length) As Object
  For i = 0 To ObjArr.Length - 1
    ResultArr(i) = GetWrappedObject(ObjArr(i))
  Next
  If UnWrapType = "" Then UnWrapType = GetType(ResultArr(0))
  P1.InitializeArray(UnWrapType,ResultArr)
  Return P1
End Sub
'Gets a wrapped object from any wrapper class that has a AsObject Sub 
'without knowing it's type
Private Sub GetWrappedObject(jObj As JavaObject) As JavaObject
  Try
  'Unwrap JOLibs
    #if Debug
    Return jObj.RunMethod("_getobject",Array(jObj))
    #end if
    #if Release
    Return jObj.RunMethod("_getobject",Null)
    #End if
  Catch
    Try
    'Unwrap B4x objects
      Return jObj.RunMethod("getObject",Null)
    Catch
      Log(LastException)
      Log("Invalid type passed to Sub " & GetType(jObj))
    End Try
    
    Return Null
  End Try
End Sub

'The following subs are here as a convienience and may not alwasy be appropriate for the type of listener added.
Private Sub FindChangeListener(Module As Object,EventName As String) As Map
    'An uninitialized list to return if not found
  Dim L As List
  Dim M As Map
  M.Initialize
  M.Put("List",L)
  M.Put("Index",-1)
  M.Put("SubName","")
  For Each K As Object In ListenersMap.Keys
    Dim Listeners As List = ListenersMap.Get(K)
    If Listeners.IsInitialized Then
      For  i = 0 To Listeners.Size - 1
        Dim LT As ListenerType = Listeners.Get(i)
        If LT.Module = Module And LT.EventName = EventName Then
          M.Put("List",Listeners)
          M.Put("Index",i)
          M.Put("SubName",K)
          Return M
        End If
      Next
    End If
  Next
  Return M
End Sub
Public Sub RemoveChangeListener(Module As Object,EventName As String) As Boolean
    'It is not always possible to remove a listener, but this will try the default method.  This may need to be changed. or removed.
  Dim M As Map = FindChangeListener(Module,EventName)
  Dim Listeners As List = M.Get("List")
  If Listeners.IsInitialized Then
    Dim Pos As Int = M.Get("Index")
    If Pos > -1 Then
      Dim LT As ListenerType = Listeners.Get(Pos)
      Listeners.RemoveAt(Pos)
      If Listeners.Size = 0 Then 
        Dim SubName As String = M.GetDefault("SubName","")
        If SubName.Contains("Listener") Then
          Try
            TJO.RunMethod("removeListener",Array(LT.Listener))
          Catch
            Log(LastException)
          End Try
        End If
      End If
      Return True
    End If
  End If
  Return False
End Sub
Public Sub RemoveAllChangeListeners(Module As Object, EventName As String)
  Dim M As Map = FindChangeListener(Module,EventName)
  Dim Listeners As List = M.Get("List")
  If Listeners.IsInitialized Then
    Dim Pos As Int = M.Get("Index")
    If Pos > -1 Then
      Dim LT As ListenerType = Listeners.Get(Pos)
      Try
        TJO.RunMethod("removeListener",Array(LT.Listener))
      Catch
        Log(LastException)
      End Try
    End If
  End If
  Listeners.clear
End Sub